<template>
  <portal-page class="q-px-lg">
    <div class="row q-gutter-lg">
      <div class="col">
        <p class="title-msg title-medium">Messages</p>
      </div>
    </div>

    <div class="row q-gutter-xl">
      <div class="col-3">
        <q-card
          flat
          class="msger-chat rounded-borders-10"
          style="bottom: 10px; position: sticky"
        >
          <q-card-section>
            <div class="row">
              <div
                v-if="roomStore.roomsLoading"
                class="col q-mt-lg"
                align="center"
              >
                <q-spinner color="primary" size="40px" :thickness="3" />
              </div>
              <div v-else-if="roomStore.rooms.length > 0" class="col">
                <q-card
                  flat
                  class="bg-grey-2 q-pa-md q-mb-md rounded-borders-10 cursor-pointer"
                  v-for="(room, key) in roomStore.rooms"
                  :key="key"
                  @click="gotoRoom(room)"
                  :class="
                    room.id === roomStore.selectedRoomID
                      ? 'card-room-selected'
                      : 'card-room'
                  "
                >
                  <div class="row">
                    <div class="col-2 q-my-auto" align="left">
                      <!-- <q-avatar style="background-color: #4c1cc0">
                        <span class="title-headline text-white">{{
                          room.room_name.slice(0, 1)
                        }}</span>
                      </q-avatar> -->

                      <custom-avatar
                        :photoUrl="room.job_seeker_picture_url"
                        :name="room.room_name"
                        userType="jobseeker"
                        fontSize="17px"
                        shadow="shadow-5"
                      />
                    </div>

                    <div class="col-8 q-my-auto q-pl-sm">
                      <div
                        class="msg-info-name"
                        :style="
                          isUnread(room.latest_message)
                            ? 'font-weight: 700'
                            : 'font-weight: 500'
                        "
                      >
                        {{ trim(getRoomName(room)) }}
                      </div>
                      <div
                        class="msg-info-details text-grey-7"
                        :style="
                          isUnread(room.latest_message)
                            ? 'font-weight: 800'
                            : ''
                        "
                      >
                        {{
                          room.latest_message !== null
                            ? trim(room.latest_message.message)
                            : ""
                        }}
                      </div>
                      <div
                        class="msg-info-details"
                        style="font-weight: 800"
                        :style="{
                          color: `${statusColor(
                            room.application.application_status.name
                          )}`,
                        }"
                      >
                        {{ room.application.application_status.name }}
                      </div>
                    </div>

                    <div class="col-2" align="right">
                      <span class="msg-info-details text-grey-7">
                        {{
                          room.latest_message !== null
                            ? formatDate(
                                room.latest_message.created_at,
                                "MMM-DD"
                              )
                            : formatDate(room.updated_at, "MMM-DD")
                        }}
                      </span>

                      <q-badge
                        v-if="isUnread(room.latest_message)"
                        class="q-ml-sm"
                        color="negative"
                        rounded
                      />
                    </div>
                  </div>
                </q-card>
              </div>

              <div
                v-else
                class="col q-mt-lg"
                style="font-size: 16px"
                align="center"
              >
                <q-img
                  class="q-mt-md"
                  width="50%"
                  src="~assets/chat_message.svg"
                />
                <p class="q-ma-xl">
                  No messages yet. You can only start a conversation with Job
                  Seekers once they submit an application.
                </p>
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>

      <div class="col" style="margin-left: 30px; margin-top: 25px">
        <q-card
          flat
          class="bg-transparent"
          style="height: 80vh"
          v-show="roomStore.selectedRoomID !== null"
        >
          <section class="msger">
            <div class="chat-header">
              <span
                class="q-ml-lg"
                style="font-weight: 700; font-size: 15px; color: #1d1d1d"
              >
                {{ roomStore.selectedRoomName }}
              </span>
            </div>
            <main
              ref="containerMessageDisplay"
              class="msger-chat"
              style="padding: 10px 0 10px 0"
            >
              <div
                v-if="roomStore.messageLoading"
                class="col q-mt-lg"
                align="center"
              >
                <q-spinner color="primary" size="40px" :thickness="3" />
              </div>
              <div v-else v-for="(message, key) in roomStore.room" :key="key">
                <div
                  :class="
                    message.user_id === userID
                      ? 'msg right-msg'
                      : 'msg left-msg'
                  "
                >
                  <div class="msg-bubble">
                    <div v-html="linkify(message.message)" />
                  </div>
                </div>
              </div>
            </main>

            <div
              v-if="
                applicationForm.application_status === 'Hired' ||
                applicationForm.application_status === 'Rejected' ||
                showEditor
              "
              class="row msger-inputarea"
            >
              <div class="col-12">
                <q-editor
                  ref="textEditor"
                  v-model.trim="form.message"
                  @update:model-value="messageDidUpdate()"
                  min-height="2rem"
                  min-width="100%"
                  :dense="$q.screen.lt.md"
                  :toolbar="[]"
                  placeholder="Enter your message here..."
                  @keydown.enter.prevent="sendMessage(form)"
                />

                <!-- :toolbar="[
                    ['bold', 'italic', 'strike', 'underline'],
                    ['link'],
                    [
                      {
                        label: $q.lang.editor.align,
                        icon: $q.iconSet.editor.align,
                        fixedLabel: true,
                        list: 'only-icons',
                        options: ['left', 'center', 'right', 'justify'],
                      },
                    ],
                    ['unordered', 'ordered', 'outdent', 'indent'],
                  ]" -->

                <!-- <q-spacer /> -->

                <div class="row" style="padding: 0 0 10px 0">
                  <div
                    class="col-8"
                    align="left"
                    style="padding: 10px 0 0 10px"
                  >
                    <span
                      class="text-negative text-left"
                      style="font-size: 12px; font-weight: 600"
                    >
                      {{ errorMessage }}
                    </span>
                  </div>
                  <div class="col-4" align="right" style="padding: 0">
                    <div class="row" style="padding: 0">
                      <div class="col" align="center">
                        <q-btn
                          v-show="!isApplicationDone"
                          unelevated
                          outline
                          class="btn-md"
                          label="CANCEL"
                          color="dark-blue"
                          style="width: 80%"
                          @click="hideMessageEditor()"
                        />
                      </div>

                      <div class="col" align="center">
                        <q-btn
                          unelevated
                          class="btn-md"
                          label="SEND"
                          style="width: 80%"
                          color="dark-blue"
                          @click="sendMessage(form)"
                          :loading="loading"
                        />
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <div v-else class="row msger-inputarea">
              <div class="col-6">
                <div class="text-grey-7 q-pa-0">
                  <label
                    class="text-caption text-weight-bold text-grey-7"
                    style="font-size: 11px"
                    >STATUS<span class="text-negative">*</span></label
                  >
                  <q-select
                    v-model="form.application_status_id"
                    @update:model-value="formatMessage(form, true)"
                    outlined
                    :options="getStatusList"
                    map-options
                    emit-value
                    dense
                    block
                  />
                </div>

                <div
                  v-if="
                    form.application_status_id &&
                    form.application_status_id === 3
                  "
                  class="text-grey-7 q-pa-0"
                >
                  <label
                    class="text-caption text-weight-bold text-grey-7"
                    style="font-size: 11px"
                    >MEETING LINK<span class="text-negative">*</span></label
                  >
                  <q-input
                    v-model="form.meeting_link"
                    dense
                    outlined
                    class="q-mt-sm"
                    @update:model-value="formatMessage(form, false)"
                  />
                </div>

                <div
                  v-if="
                    form.application_status_id &&
                    (form.application_status_id === 2 ||
                      form.application_status_id === 4)
                  "
                  class="text-grey-7 q-pa-0"
                >
                  <label
                    class="text-caption text-weight-bold text-grey-7"
                    style="font-size: 11px"
                    >OFFICE ADDRESS<span class="text-negative">*</span></label
                  >
                  <q-input
                    v-model="form.office_address"
                    dense
                    outlined
                    class="q-mt-sm"
                    @update:model-value="formatMessage(form, false)"
                  />
                </div>

                <div
                  v-if="
                    form.application_status_id &&
                    (form.application_status_id === 2 ||
                      form.application_status_id === 4)
                  "
                  class="text-grey-7 q-pa-0"
                >
                  <label
                    class="text-caption text-weight-bold text-grey-7"
                    style="font-size: 11px"
                    >DATE & TIME<span class="text-negative">*</span></label
                  >
                  <q-input dense outlined v-model="form.datetime">
                    <template v-slot:prepend>
                      <q-icon
                        name="eva-calendar-outline"
                        class="cursor-pointer"
                      >
                        <q-popup-proxy
                          cover
                          transition-show="scale"
                          transition-hide="scale"
                        >
                          <q-date
                            v-model="form.datetime"
                            mask="MM/DD/YYYY hh:mm A"
                            :options="
                              (date) =>
                                date >= formatDate(Date.now(), 'YYYY/MM/DD')
                            "
                            @update:model-value="formatMessage(form, false)"
                          >
                            <div class="row items-center justify-end">
                              <q-btn
                                v-close-popup
                                label="Close"
                                color="primary"
                                flat
                              />
                            </div>
                          </q-date>
                        </q-popup-proxy>
                      </q-icon>
                    </template>

                    <template v-slot:append>
                      <q-icon name="eva-clock-outline" class="cursor-pointer">
                        <q-popup-proxy
                          cover
                          transition-show="scale"
                          transition-hide="scale"
                        >
                          <q-time
                            v-model="form.datetime"
                            mask="MM/DD/YYYY hh:mm A"
                            @update:model-value="formatMessage(form, false)"
                          >
                            <div class="row items-center justify-end">
                              <q-btn
                                v-close-popup
                                label="Close"
                                color="primary"
                                flat
                              />
                            </div>
                          </q-time>
                        </q-popup-proxy>
                      </q-icon>
                    </template>
                  </q-input>
                </div>
              </div>

              <div
                v-show="!form.application_status_id"
                class="col-6"
                style="
                  display: flex;
                  justify-content: center;
                  align-items: center;
                  margin-top: 15px;
                "
              >
                <div class="col" align="center">
                  <q-btn
                    unelevated
                    label="SEND A MESSAGE"
                    class="btn--shade-2 btn-md text-white"
                    style="width: 60%"
                    @click="showMessageEditor()"
                  />
                </div>
              </div>

              <div v-show="form.application_status_id" class="col-6">
                <div class="col text-grey-7">
                  <label
                    class="text-caption text-weight-bold text-grey-7"
                    style="font-size: 11px"
                    >MESSAGE PREVIEW</label
                  >
                  <q-input v-model="form.message" outlined type="textarea" />
                </div>

                <div
                  v-if="form.application_status_id"
                  style="
                    display: flex;
                    justify-content: center;
                    align-items: center;
                    margin-top: -5px;
                  "
                >
                  <div class="col" align="center">
                    <q-btn
                      unelevated
                      outline
                      class="btn-md q-ml-md"
                      label="CANCEL"
                      color="green-10"
                      style="width: 80%"
                      @click="cancelStatus()"
                      :loading="loading"
                    />
                  </div>

                  <div class="col" align="center">
                    <q-btn
                      unelevated
                      class="btn-md q-mr-md"
                      label="SEND"
                      color="green-10"
                      style="width: 80%"
                      @click="updateStatus(applicationForm.id, form)"
                      :loading="loading"
                    />
                  </div>
                </div>
              </div>
            </div>
          </section>
        </q-card>
      </div>

      <div class="col-3">
        <q-card
          flat
          class="msger-chat rounded-borders-10"
          style="bottom: 10px; position: sticky"
          v-if="
            roomStore.selectedRoomID !== null &&
            applicationForm.id &&
            jobForm.id
          "
        >
          <q-card-section class="q-pa-md">
            <span class="title-xsmall text-grey-7">APPLICATION STATUS</span>
            <div class="row q-my-md">
              <div class="col">
                <div
                  style="
                    height: 40px;
                    display: flex;
                    align-items: center;
                    padding: 10px;
                    font-weight: 800;
                    font-size: 15px;
                    border-radius: 10px;
                  "
                  :style="{
                    color: `${statusColor(applicationForm.application_status)}`,
                    background: `${statusBackgroundColor(
                      applicationForm.application_status
                    )}`,
                  }"
                >
                  {{ applicationForm.application_status }}
                </div>
              </div>
            </div>

            <div class="row q-my-md">
              <!-- <div class="col q-mr-md"> -->
              <q-btn
                unelevated
                label="VIEW CV / RESUME"
                style="width: 100%"
                class="btn--shade-2 btn-md text-white"
                @click="
                  openFile(roomStore.selectedRoom.job_seeker_cv_or_resume_url)
                "
              />
              <!-- </div> -->

              <!-- <div class="col">
                <q-btn
                  unelevated
                  style="width: 100%"
                  label="VIEW COVER LETTER"
                  class="btn--shade-2 btn-md text-white"
                />
              </div> -->
            </div>
          </q-card-section>

          <q-card-section>
            <span class="title-xsmall text-grey-7">ABOUT THE JOB</span>
            <div class="row q-pt-lg q-gutter-md">
              <!-- <q-avatar rounded color="positive" size="60px">
                <span class="title-headline text-white">{{
                  jobForm.company_name.slice(0, 1)
                }}</span>
              </q-avatar> -->
              <custom-avatar
                :photoUrl="roomStore.selectedRoom.employer_picture_url"
                :name="jobForm.company_name"
                userType="employer"
                fontSize="17px"
                size="60px"
                :circle="false"
              />
              <div>
                <span
                  class="text-weight-bold"
                  style="font-size: 17px; color: #1d1d1d"
                >
                  {{ jobForm.job_title }}
                </span>
                <p style="font-size: 15px; color: #1d1d1d">
                  {{ jobForm.company_name }}
                </p>
              </div>
            </div>

            <div
              class="row q-pt-lg"
              v-show="
                jobForm.full_time === true ||
                jobForm.part_time === true ||
                jobForm.freelance_or_contract === true ||
                jobForm.entry_level === true ||
                jobForm.intermediate === true ||
                jobForm.expert === true ||
                jobForm.on_site === true ||
                jobForm.remote === true ||
                jobForm.hybrid === true ||
                jobForm.years_of_experience >= 1 ||
                jobForm.vacancy_number >= 1
              "
            >
              <div class="col q-gutter-md">
                <!-- TAGS FOR JOB TYPE -->
                <q-badge
                  v-if="jobForm.full_time === true"
                  class="badge"
                  color="white"
                  label="FULL-TIME"
                />
                <q-badge
                  v-if="jobForm.part_time === true"
                  class="badge"
                  color="white"
                  label="PART-TIME"
                />
                <q-badge
                  v-if="jobForm.freelance_or_contract === true"
                  class="badge"
                  color="white"
                  label="FREELANCE/CONTRACT"
                />

                <!-- TAGS FOR EXPERIENCE LEVEL -->
                <q-badge
                  v-if="jobForm.entry_level === true"
                  class="badge"
                  color="white"
                  label="ENTRY LEVEL"
                />
                <q-badge
                  v-if="jobForm.intermediate === true"
                  class="badge"
                  color="white"
                  label="INTERMEDIATE"
                />
                <q-badge
                  v-if="jobForm.expert === true"
                  class="badge"
                  color="white"
                  label="EXPERT"
                />

                <!-- TAGS FOR OTHERS -->
                <q-badge
                  v-if="jobForm.on_site === true"
                  class="badge"
                  color="white"
                  label="ON-SITE"
                />
                <q-badge
                  v-if="jobForm.remote === true"
                  class="badge"
                  color="white"
                  label="REMOTE"
                />
                <q-badge
                  v-if="jobForm.hybrid === true"
                  class="badge"
                  color="white"
                  label="HYBRID"
                />

                <q-badge
                  v-if="jobForm.years_of_experience >= 1"
                  class="badge"
                  color="white"
                >
                  {{
                    jobForm.years_of_experience === 1
                      ? jobForm.years_of_experience + " YEAR EXPERIENCE"
                      : jobForm.years_of_experience + " YEARS EXPERIENCE"
                  }}
                </q-badge>
                <q-badge
                  v-if="jobForm.vacancy_number >= 1"
                  class="badge"
                  color="white"
                >
                  {{
                    jobForm.vacancy_number === 1
                      ? jobForm.vacancy_number + " VACANCY"
                      : jobForm.vacancy_number + " VACANCIES"
                  }}
                </q-badge>
              </div>
            </div>

            <div class="row q-mt-lg">
              <div class="col">
                <span
                  class="title-6"
                  style="color: #1d1d1d"
                  v-html="jobForm.job_description"
                ></span>
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>
    </div>
  </portal-page>
</template>

<script>
import PortalPage from "src/layouts/portals/PortalPage.vue";
import dayjs from "dayjs";
import useApplicationHook from "../hooks/applicationHook";
import { defineComponent, ref, reactive, computed } from "vue";
import { useRoom } from "../store/room";
import { useApplication } from "../store/application";
import { pusher } from "boot/pusher";
import { LocalStorage } from "quasar";
import { onMounted, onUnmounted, watch } from "vue";
import { date } from "quasar";
import usePageRouter from "src/hooks/pageRouter";
import { MESSAGES_EMPLOYER_ROUTE_NAMES } from "../constants";
import { EmployerApplicationApi } from "src/hooks/api";
import _ from "lodash";
import CustomAvatar from "src/components/CustomAvatar.vue";

import linkifyHtml from "linkify-html";
// const urlRegex = require("url-regex");

export default defineComponent({
  name: "MessagesEmployerPage",
  components: {
    PortalPage,
    CustomAvatar,
  },

  setup() {
    const roomStore = useRoom();
    const { showRoom, addRoomMessage, updateRoomStatus, resetRooms } =
      roomStore;

    const applicationStore = useApplication();
    const { showApplication, setApplicationDetail } = applicationStore;

    const { route, router } = usePageRouter();

    onMounted(() => {
      console.log("Employer onMounted");
      pusherBind();

      if (route.params.roomid) {
        showCurrentRoom();
      } else {
        resetRooms();
      }

      let scrollDiv = containerMessageDisplay.value;
      scrollDiv.addEventListener("scroll", handleScroll);
    });

    onUnmounted(() => {
      console.log("Employer onUnmounted");
      // pusher.connection.unbind_all();
    });

    watch(
      () => route.params.roomid,
      (newRoomId) => {
        if (!newRoomId) {
          resetRooms();
        }
      }
    );

    // const jobStore = useJob();
    // const { showJob } = jobStore;

    const { doUpdateApplicationStatus } = useApplicationHook();
    const loading = ref(false);
    const isError = ref(false);
    const errorMessage = ref("");
    const showEditor = ref(false);
    const textEditor = ref(null);
    const roomLoaded = ref(false);

    const form = reactive({
      application_status_id: null,
      datetime: null,
      office_address: null,
      meeting_link: null,
      phone_or_email: null,
      message: "",
    });

    const applicationForm = reactive({
      id: null,
      application_status: null,
      cover_letter: null,
      cv_or_resume_url: null,
      job_post_id: null,
    });

    const linkOptions = {
      defaultProtocol: "https",
      tagName: "a",
      target: {
        url: "_blank",
      },
    };

    watch(
      () => _.cloneDeep(applicationForm),
      (currentValue, oldValue) => {
        if (currentValue.application_status != null) {
          if (
            currentValue.application_status != oldValue.application_status &&
            currentValue.id == oldValue.id
          ) {
            updateRoomStatus(currentValue.application_status);
          }
        }
      }
    );

    watch(
      () => roomStore.roomCount,
      (currentValue, oldValue) => {
        if (oldValue == 0 && currentValue > 0 && !roomLoaded.value) {
          showCurrentRoom();
        }
      }
    );

    const jobForm = reactive({
      id: null,
      job_title: null,
      company_name: null,
      full_time: null,
      part_time: null,
      freelance_or_contract: null,
      entry_level: null,
      intermediate: null,
      expert: null,
      on_site: null,
      remote: null,
      hybrid: null,
      job_description: null,
      years_of_experience: null,
      vacancy_number: null,
    });

    const message = ref("");
    const userID = LocalStorage.getItem("auth").id;
    const containerMessageDisplay = ref(null);
    const atBottom = ref(false);

    const statusOptions = ref([
      {
        label: "Pending",
        value: 1,
      },
      {
        label: "1st Interview Pending",
        value: 2,
      },
      {
        label: "1st Interview Confirmed",
        value: 3,
      },
      {
        label: "2nd Interview Pending",
        value: 4,
      },
      {
        label: "2nd Interview Confirmed",
        value: 5,
      },
      {
        label: "Hired",
        value: 6,
      },
      {
        label: "Rejected",
        value: 7,
      },
    ]);

    const showCurrentRoom = () => {
      let room = roomStore.rooms.find(
        (item) => item.id === Number(route.params.roomid)
      );
      if (room) {
        roomLoaded.value = true;
        fetchMessages(room.id, room.application, isUnread(room.latest_message));
      }
    };

    const pusherBind = () => {
      pusher.connection.bind("message", (msg) => {
        if (msg.event == "message") {
          console.log("event: message");
          console.log("message: ", msg);
          manageNewMessage(msg.data.data);
        }
      });
    };

    const manageNewMessage = async (message) => {
      if (message.user_id != userID) {
        if (message.room_id == roomStore.selectedRoomID) {
          if (
            applicationStore.currentApplicationStatusID !=
            message.applicationStatusId
          ) {
            getApplication(applicationStore.selectedApplicationID);
          }

          addRoomMessage(message);
          setTimeout(() => {
            if (atBottom.value) {
              goToBottom(true);
            }
          }, 200);
        }
      } else {
        addRoomMessage(message);
        setTimeout(() => {
          goToBottom(true);
        }, 200);
      }
    };

    const handleScroll = (e) => {
      let scrollDiv = containerMessageDisplay.value;
      atBottom.value =
        scrollDiv.scrollHeight - 100 <=
        e.target.scrollTop + scrollDiv.offsetHeight;
    };

    const isUnread = (message) => {
      if (message == null) return false;
      if (message.user_id != userID) {
        return message.read_at == null;
      }
      return false;
    };

    const statusColor = (status) => {
      switch (status) {
        case "Pending":
          return "#9E9E9E";
          break;
        case "1st Interview Pending":
          return "#FF9800";
          break;
        case "1st Interview Confirmed":
          return "#FFC107";
          break;
        case "2nd Interview Pending":
          return "#06A9F4";
          break;
        case "2nd Interview Confirmed":
          return "#009688";
          break;
        case "Hired":
          return "#4CAF50";
          break;
        case "Rejected":
          return "#F44336";
          break;
        default:
          return "#F0F0F0";
          break;
      }
    };

    const statusBackgroundColor = (status) => {
      switch (status) {
        case "Pending":
          return "#F5F5F5";
          break;
        case "1st Interview Pending":
          return "#FFF3E0";
          break;
        case "1st Interview Confirmed":
          return "#FFF8E1";
          break;
        case "2nd Interview Pending":
          return "#E1F5FE";
          break;
        case "2nd Interview Confirmed":
          return "#E0F2F1";
          break;
        case "Hired":
          return "#E8F5E9";
          break;
        case "Rejected":
          return "#FFEBEE";
          break;
        default:
          return "#F0F0F0";
          break;
      }
    };

    const goToBottom = (animated) => {
      let scrollDiv = containerMessageDisplay.value;
      scrollDiv.scrollTo({
        top: scrollDiv.scrollHeight,
        behavior: animated ? "smooth" : "instant",
      });
    };

    const openFile = (url) => {
      window.open(url);
    };

    const formatDate = (date, format) => {
      return dayjs(date).format(format);
    };

    const gotoRoom = (room) => {
      router.push({
        name: MESSAGES_EMPLOYER_ROUTE_NAMES.MessageDetail.name,
        params: {
          roomid: room.id,
        },
      });

      fetchMessages(room.id, room.application, isUnread(room.latest_message));
    };

    const fetchMessages = async (room_id, application, isUnread) => {
      form.application_status_id = null;
      form.datetime = null;
      form.office_address = null;
      form.meeting_link = null;
      form.phone_or_email = null;
      form.message = "";
      showEditor.value = false;

      setApplication(application);
      await showRoom(room_id, isUnread).then(() => {
        goToBottom(false);
      });
    };

    const setApplication = (application) => {
      setApplicationDetail(application);
      applicationForm.id = application.id;
      applicationForm.application_status = application.application_status.name;
      applicationForm.cover_letter = application.cover_letter;
      applicationForm.cv_or_resume_url = application.cv_or_resume_url;
      applicationForm.job_post_id = application.job_post_id;

      jobForm.id = application.job_post.id;
      jobForm.company_name = application.job_post.company_name;
      jobForm.job_title = application.job_post.job_title;
      jobForm.full_time = application.job_post.full_time;
      jobForm.part_time = application.job_post.part_time;
      jobForm.freelance_or_contract =
        application.job_post.freelance_or_contract;
      jobForm.entry_level = application.job_post.entry_level;
      jobForm.intermediate = application.job_post.intermediate;
      jobForm.expert = application.job_post.expert;
      jobForm.on_site = application.job_post.on_site;
      jobForm.remote = application.job_post.remote;
      jobForm.hybrid = application.job_post.hybrid;
      jobForm.job_description = application.job_post.job_description;
      jobForm.years_of_experience = application.job_post.years_of_experience;
      jobForm.vacancy_number = application.job_post.vacancy_number;
    };

    const getApplication = async (applicationID) => {
      await showApplication(applicationID).then((data) => {
        if (data.success) {
          applicationForm.id = applicationStore.application.id;
          applicationForm.application_status =
            applicationStore.application.application_status.name;
          applicationForm.cover_letter =
            applicationStore.application.cover_letter;
          applicationForm.cv_or_resume_url =
            applicationStore.application.cv_or_resume_url;
          applicationForm.job_post_id =
            applicationStore.application.job_post_id;

          jobForm.id = applicationStore.application.job_post.id;
          jobForm.company_name =
            applicationStore.application.job_post.company_name;
          jobForm.job_title = applicationStore.application.job_post.job_title;
          jobForm.full_time = applicationStore.application.job_post.full_time;
          jobForm.part_time = applicationStore.application.job_post.part_time;
          jobForm.freelance_or_contract =
            applicationStore.application.job_post.freelance_or_contract;
          jobForm.entry_level =
            applicationStore.application.job_post.entry_level;
          jobForm.intermediate =
            applicationStore.application.job_post.intermediate;
          jobForm.expert = applicationStore.application.job_post.expert;
          jobForm.on_site = applicationStore.application.job_post.on_site;
          jobForm.remote = applicationStore.application.job_post.remote;
          jobForm.hybrid = applicationStore.application.job_post.hybrid;
          jobForm.job_description =
            applicationStore.application.job_post.job_description;
          jobForm.years_of_experience =
            applicationStore.application.job_post.years_of_experience;
          jobForm.vacancy_number =
            applicationStore.application.job_post.vacancy_number;
        }
      });
    };

    const formatMessage = (form, fromStatus) => {
      if (fromStatus) {
        form.datetime = null;
        form.office_address = null;
        form.meeting_link = null;
        form.phone_or_email = null;
        form.message = "";

        setTimeout(() => {
          goToBottom(true);
        }, 300);
      }
      if (form.application_status_id) {
        switch (form.application_status_id) {
          case 1: // Pending
            break;
          case 2: // 1st Interview Pending
            if (form.datetime)
              form.message = `You have been scheduled for an online interview with the HR Team on ${date.formatDate(
                form.datetime,
                "MMMM DD, YYYY"
              )} at ${date.formatDate(
                form.datetime,
                "hh:mm A"
              )}. Please confirm to get the meeting link. If you have any questions or concerns, you may contact us at phone/email.`;
            break;
          case 3: // 1st Interview Confirmed
            if (form.meeting_link)
              form.message = `Thank you for confirming. Please use this meeting link: ${form.meeting_link}.`;
            break;
          case 4: // 2nd Interview Pending
            if (form.office_address && form.datetime)
              form.message = `Congratulations! You have advanced to the next step. Please come to ${
                form.office_address
              } for the 2nd round of interview on ${date.formatDate(
                form.datetime,
                "MMMM DD, YYYY"
              )} at ${date.formatDate(form.datetime, "hh:mm A")}.`;
            break;
          case 5: // 2nd Interview Confirmed
            form.message =
              "Thank you for confirming. We look forward to meeting with you to discuss your suitability for the role.";
            break;
          case 6: // Hired
            form.message = "Congratulations!";
            break;
          case 7: // Rejected
            form.message =
              "We regret to inform you that you have not been selected for the position you are applying for. Please check other positions and try again. Thank you.";
            break;
        }
      }
    };

    const sendMessage = async (payload) => {
      if (payload.message.length > 0) {
        loading.value = true;
        isError.value = false;
        errorMessage.value = "";

        await EmployerApplicationApi.update(
          applicationStore.application.id,
          payload
        )
          .then((response) => {
            payload.message = "";
            // if (response.data.success) {
            //   if (form.status.length > 0) {
            //     getApplication(applicationStore.selectedApplicationID);
            //   }
            // }
          })
          .catch((error) => {
            isError.value = true;
            errorMessage.value = error?.response?.data?.message.toUpperCase();
          })
          .finally(() => {
            loading.value = false;
          });
      } else {
        errorMessage.value = "THE MESSAGE FIELD IS REQUIRED.";
      }
    };

    const showMessageEditor = () => {
      showEditor.value = true;
      setTimeout(() => {
        goToBottom(true);
        textEditor.value.focus();
      }, 300);
    };

    const hideMessageEditor = () => {
      showEditor.value = false;
      setTimeout(() => {
        goToBottom(true);
      }, 300);
    };

    const cancelStatus = () => {
      setTimeout(() => {
        goToBottom(true);
      }, 300);
      form.application_status_id = null;
      form.datetime = null;
      form.office_address = null;
      form.meeting_link = null;
      form.phone_or_email = null;
      form.message = null;
    };

    const updateStatus = async (application_id, form) => {
      await doUpdateApplicationStatus(application_id, form).then((data) => {
        if (data.success) {
          form.application_status_id = null;
          form.datetime = null;
          form.office_address = null;
          form.meeting_link = null;
          form.phone_or_email = null;
          form.message = null;

          getApplication(applicationStore.selectedApplicationID);
        }
      });
    };

    const getStatusList = computed(() => {
      // console.log(
      //   "application_status_id: ",
      //   applicationStore.application.application_status_id
      // );
      return statusOptions.value.filter(
        (option) =>
          option.value >
          (applicationStore.application != null
            ? applicationStore.application.application_status_id
            : 1)
      );
    });

    const isApplicationDone = computed(() => {
      return (
        applicationForm.application_status === "Hired" ||
        applicationForm.application_status === "Rejected"
      );
    });

    const messageDidUpdate = () => {
      if (form.message.length > 0 && form.message != " ") {
        errorMessage.value = "";
      }
    };

    const trim = (message) => {
      return message.replaceAll("&nbsp;", "").replace(/<\/?[^>]+(>|$)/g, "");
    };

    const linkify = (message) => {
      let string = linkifyHtml(message, linkOptions);
      return string
        .replaceAll("&nbsp;", "")
        .replaceAll("<a ", '<a style="color: #8AB4F8" ');
    };

    const getRoomName = (room) => {
      return room.room_name + "(" + room.application.job_post.job_title + ")";
    };

    return {
      roomStore,
      applicationStore,
      // jobStore,
      form,
      applicationForm,
      jobForm,
      message,
      userID,
      loading,
      isError,
      errorMessage,
      fetchMessages,
      formatMessage,
      sendMessage,
      updateStatus,
      cancelStatus,
      openFile,
      formatDate,
      isUnread,
      containerMessageDisplay,
      handleScroll,
      atBottom,
      statusColor,
      statusBackgroundColor,
      getApplication,
      setApplication,
      getStatusList,
      isApplicationDone,
      gotoRoom,
      router,
      messageDidUpdate,
      trim,
      linkify,
      showEditor,
      showMessageEditor,
      hideMessageEditor,
      textEditor,
      getRoomName,
    };
  },
});
</script>

<style lang="scss" scoped>
:root {
  --body-bg: linear-gradient(135deg, #f5f7fa 0%, #c3cfe2 100%);
  --msger-bg: #fff;
  --border: 2px solid #ddd;
  --left-msg-bg: #ececec;
  --right-msg-bg: #579ffb;
}

html,
body {
  display: flex;
  justify-content: center;
  align-items: center;
  margin: 0;
  height: 100%;
  background-image: var(--body-bg);
  overflow: hidden;
}

.msger {
  display: flex;
  flex-flow: column wrap;
  justify-content: space-between;
  width: 100%;
  max-width: 867px;
  margin: 25px 10px;
  height: calc(100% - 50px);
  // background: var(--msger-bg);
  background: #f5f5f5;
  border-radius: 10px;
  overflow: hidden;
}

.chat-header {
  background: white;
  height: 55px;
  border-top-left-radius: 10px;
  border-top-right-radius: 10px;
  display: flex;
  align-items: center;
  -webkit-box-shadow: 0 10px 20px black;
  -moz-box-shadow: 0 10px 20px black;
  box-shadow: 0 -10px 20px black;
  z-index: 1;
}

.msger-chat {
  flex: 1;
  overflow-y: auto;
  height: 75vh !important;
}
.msger-chat::-webkit-scrollbar {
  width: 6px;
}
.msger-chat::-webkit-scrollbar-track {
  background: #ddd;
}
.msger-chat::-webkit-scrollbar-thumb {
  background: #bdbdbd;
}
.msger-chat::-webkit-scrollbar {
  display: none;
}
.msger-chat {
  -ms-overflow-style: none;
  scrollbar-width: none;
}

.msg {
  display: flex;
  align-items: flex-end;
  margin-bottom: 10px;
}
.msg:last-of-type {
  margin: 0;
}
.msg-img {
  width: 50px;
  height: 50px;
  margin-right: 10px;
  background: #ddd;
  background-repeat: no-repeat;
  background-position: center;
  background-size: cover;
  border-radius: 50%;
}
.msg-bubble {
  max-width: 450px;
  padding: 10px 15px 10px 15px;
  border-radius: 15px;
  background: #fff;
  margin: 8px 15px 8px 15px;
}
.msg-info {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: 10px;
}
.msg-info-name {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  margin-right: 10px;
  font-weight: 700;
  font-size: 15px;
  line-height: 20px;
}
.msg-info-details {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  font-weight: 400;
  font-size: 11px;
  line-height: 15px;
}
.msg-info-time {
  font-size: 0.85em;
}

.left-msg .msg-bubble {
  border-bottom-left-radius: 0;
}

.right-msg {
  flex-direction: row-reverse;
}
.right-msg .msg-bubble {
  background: $brand-3;
  border-bottom-right-radius: 0;
  color: white;
}
.right-msg .msg-img {
  margin: 0 0 0 10px;
}
.msg-actions {
  position: sticky;
  bottom: 10px;
}

.msger-inputarea {
  display: flex;
  // border-top: var(--border);
  background: #ffffff;
  position: sticky;
  // bottom: 10px;
  border-bottom-left-radius: 10px;
  border-bottom-right-radius: 10px;
  -webkit-box-shadow: 0 10px 20px black;
  -moz-box-shadow: 0 10px 20px black;
  box-shadow: 0 10px 20px black;
}
.msger-inputarea * {
  padding: 10px;
  border: none;
  // border-radius: 10px;
  // font-size: 1em;
}
.msger-input {
  flex: 1;
  background: #ddd;
}
.msger-send-btn {
  margin-left: 10px;
  background: rgb(0, 196, 65);
  color: #fff;
  font-weight: bold;
  cursor: pointer;
  transition: background 0.23s;
}
.msger-send-btn:hover {
  background: rgb(0, 180, 50);
}

.q-editor {
  // background: #f5f5f5;
  width: 100%;
}

#view {
  width: 180px !important;
}
.q-card__section--vert {
  padding: 20px;
}

.card-room {
  &:hover {
    background-color: #e6f0e9 !important;
    // border: 1px solid #174c76;
    transition: ease 0.2s;
  }
}

.card-room-selected {
  background-color: #e6f0e9 !important;
  border: 1px solid #016925;
  transition: ease 0.2s;
}

.title-msg {
  color: $brand-3 !important;
  margin: 0 !important;
  padding-top: 35px !important;
  padding-bottom: 35px !important;
}
</style>
